--- pmlist.cpp.orig	Fri Jan  3 04:14:24 2003
+++ pmlist.cpp	Sun May  9 11:27:10 2004
@@ -31,6 +31,8 @@
 #include <unistd.h>
 #include <iostream>
 
+extern char *ExtIf;
+
 PortMapList::PortMapList()
 {
 
@@ -182,8 +184,16 @@
 {
 	char command[255];
 
+#ifdef __linux__
 	sprintf(command,"/usr/sbin/iptables -t nat -A PREROUTING -p %s -d %s --dport %d -j DNAT --to %s:%d", Proto, ExtIP, ExtPort, IntIP, IntPort);
 	system(command);
+#else
+	FILE *ipnat = popen("/usr/sbin/ipnat -f -", "w");
+	if (ipnat == NULL) return 0;
+	snprintf(command, 255, "rdr %s %s/32 port %d -> %s port %d %s\n", ExtIf, ExtIP, ExtPort, IntIP, IntPort, Proto);
+	fprintf(ipnat, command);
+	pclose(ipnat);
+#endif
 
 	return (1);
 }
@@ -218,9 +228,16 @@
 {
 	char command[255];
 	
-
+#ifdef __linux__
 	sprintf(command, "/usr/sbin/iptables -t nat -D PREROUTING -p %s -d %s --dport %d -j DNAT --to %s:%d", Proto, ExtIP, ExtPort, IntIP, IntPort);
 	system(command);	
+#else
+	FILE *ipnat = popen("/usr/sbin/ipnat -rf -", "w");
+	if (ipnat == NULL) return 0;
+	snprintf(command, 255, "rdr %s %s/32 port %d -> %s port %d %s\n", ExtIf, ExtIP, ExtPort, IntIP, IntPort, Proto);
+	fprintf(ipnat, command);
+	pclose(ipnat);
+#endif
 	return (1);
 }
 
